︠838499b0-59f5-4b82-83f7-93faee7f9675s︠
from copy import deepcopy
from itertools import combinations
def checkIfRefinement(smaller, larger):
    isRefinement = False
    if (smaller == larger):
        isRefinement = True #every partition is a refinement of itself
        return isRefinement
    elif (len(smaller)>=len(larger)): #larger can otherwise only be a refinement if it has more elements than smaller
        return isRefinement
    else:
        smallerCopy = list(deepcopy(smaller))
        largerCopy = list(deepcopy(larger))
        i=0
        while (i < len(smallerCopy)): #any elements that are the same in each can be removed to make computation simpler
            for j in range(len(largerCopy)):
                if (smallerCopy[i]==largerCopy[j]):
                    smallerCopy.pop(i)
                    i-=1
                    largerCopy.pop(j)
                    break
            i+=1
        partitionSpaces = list(combinations(range(1,len(largerCopy)),len(smallerCopy)-1))
        toCheck = []
        for i in partitionSpaces:
            thisPartition = []
            currentPosition = 0
            for j in range(len(i)):
                thisPartition.append(largerCopy[currentPosition:i[j]])
                currentPosition = i[j]
            thisPartition.append(largerCopy[currentPosition:])
            finalPartition = []
            for aPart in thisPartition:
                sum = 0
                for aNum in aPart:
                    sum+=aNum
                finalPartition.append(sum)
            toCheck.append(finalPartition)
        for i in toCheck:
            if(i==smallerCopy):
                isRefinement=True
        return isRefinement
from collections import Counter
def counterSubset(list1, list2):
    c1, c2 = Counter(list1), Counter(list2)
    for k, n in c1.items():
        if n > c2[k]:
            return False
    return True
def getReplacements(n,aPartition):
    replacementPairs = []
    replacements = []
    subpartitions = []
    for i in range(1,len(aPartition)):
        someCombinations = list(combinations(aPartition,i))
        for j in someCombinations:
            subpartitions.append(list(j))
    for i in range(len(subpartitions)):
        for j in range(i+1,len(subpartitions)):
            iTotal = 0
            jTotal = 0
            for k in subpartitions[i]:
                iTotal+=k
            for k in subpartitions[j]:
                jTotal+=k
            if(iTotal==jTotal and (iTotal+jTotal)<=n):
                replacementPairs.append([subpartitions[i],subpartitions[j]])
    for i in replacementPairs:
        copy1 = list(deepcopy(aPartition))
        copy2 = list(deepcopy(aPartition))
        for j in i[0]:
            copy1.remove(j)
            copy2.append(j)
        for j in i[1]:
            copy1.append(j)
            copy2.remove(j)
        copy1 = list(reversed(sorted(copy1)))
        copy2 = list(reversed(sorted(copy2)))
        replacements.append(copy1)
        replacements.append(copy2)
    uniqueReplacements = []
    for i in replacements:
        if (i not in uniqueReplacements) and (i != aPartition):
            uniqueReplacements.append(i)
    return uniqueReplacements
def isSpecialFamily(n,partitionFamily):
    familyWithReplacements = []
    mustAdd = []
    for aPartition in partitionFamily:
        familyWithReplacements.append(aPartition)
        replacementSet = getReplacements(n,aPartition)
        for aReplacement in replacementSet:
            familyWithReplacements.append(aReplacement)
    isSpecial = True
    possiblePartitions = Partitions(n).list()
    allIntegers = []
    for aPartition in familyWithReplacements:
        for anInteger in aPartition:
            allIntegers.append(anInteger)
    replacements = []
    for i in possiblePartitions:
        if counterSubset(i,allIntegers):
            replacements.append(i)
    for i in replacements:
        hasRefinement = False
        for j in partitionFamily:
            if (checkIfRefinement(i,j)):
                hasRefinement = True
        if(hasRefinement==False):
            isSpecial = False
            mustAdd.append(i)
            break
    if(isSpecial==False):
        return(mustAdd[0])
    else:
        return([])
def findSmallestFamily(n,partitionFamily):
    done = False
    family = partitionFamily
    while(done==False):
        toAdd = isSpecialFamily(n,family)
        numSingletons = 0
        smallest = n+1
        for i in toAdd:
            if i==1:
                numSingletons+=1
            elif(i<smallest):
                smallest = i
        if(toAdd==[]):
            done=True
            uniqueFamily = []
            toRemove=[]
            for temp1 in family:
                for temp2 in family:
                    if (checkIfRefinement(temp1,temp2) and temp1!=temp2):
                        toRemove.append(temp1)
            for temp1 in toRemove:
                if(temp1 in family):
                    family.remove(temp1)
            return family
        elif(smallest>numSingletons):
            partitionFamily.append(toAdd)
        else:
            done=True
            return("Not possible")
︡cc1e6e6e-c240-46c6-8d12-50f20a09dd04︡
︠a4ec59b3-ef62-453e-bfd9-233429b12440︠









